DiskFileItem (Apache Tomcat 8.5.83 API Documentation)

Package org.apache.tomcat.util.http.fileupload.disk

## Class DiskFileItem

- java.lang.Object
- - org.apache.tomcat.util.http.fileupload.disk.DiskFileItem

- All Implemented Interfaces:
    `FileItem`, `FileItemHeadersSupport`

      public class DiskFileItem
      extends java.lang.Object
      implements FileItem

  The default implementation of the `FileItem` interface.

  After retrieving an instance of this class from a `FileUpload` instance (see `#parseRequest(org.apache.tomcat.util.http.fileupload.RequestContext)`), you may either request all contents of file at once using `get()` or request an `InputStream` with `getInputStream()` and process the file without attempting to load it into memory, which may come handy with large files.

  Temporary files, which are created for file items, should be deleted later on.

  Since:
    FileUpload 1.1

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `DEFAULT_CHARSET` | Default content charset to be used when no explicit charset parameter is provided by the sender.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DiskFileItem​(java.lang.String fieldName, java.lang.String contentType, boolean isFormField, java.lang.String fileName, int sizeThreshold, java.io.File repository)` | Constructs a new `DiskFileItem` instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `delete()` | Deletes the underlying storage for a file item, including deleting any associated temporary disk file.
    `protected void` | `finalize()` | Removes the file contents from the temporary storage.
    `byte[]` | `get()` | Returns the contents of the file as an array of bytes.
    `java.lang.String` | `getCharSet()` | Returns the content charset passed by the agent or `null` if not defined.
    `java.lang.String` | `getContentType()` | Returns the content type passed by the agent or `null` if not defined.
    `java.lang.String` | `getDefaultCharset()` | Returns the default charset for use when no explicit charset parameter is provided by the sender.
    `java.lang.String` | `getFieldName()` | Returns the name of the field in the multipart form corresponding to this file item.
    `FileItemHeaders` | `getHeaders()` | Returns the file item headers.
    `java.io.InputStream` | `getInputStream()` | Returns an `InputStream` that can be used to retrieve the contents of the file.
    `java.lang.String` | `getName()` | Returns the original file name in the client's file system.
    `java.io.OutputStream` | `getOutputStream()` | Returns an `OutputStream` that can be used for storing the contents of the file.
    `long` | `getSize()` | Returns the size of the file.
    `java.io.File` | `getStoreLocation()` | Returns the `File` object for the `FileItem`'s data's temporary location on the disk.
    `java.lang.String` | `getString()` | Returns the contents of the file as a String, using the default character encoding.
    `java.lang.String` | `getString​(java.lang.String charset)` | Returns the contents of the file as a String, using the specified encoding.
    `protected java.io.File` | `getTempFile()` | Creates and returns a `File` representing a uniquely named temporary file in the configured repository path.
    `boolean` | `isFormField()` | Determines whether or not a `FileItem` instance represents a simple form field.
    `boolean` | `isInMemory()` | Provides a hint as to whether or not the file contents will be read from memory.
    `void` | `setDefaultCharset​(java.lang.String charset)` | Sets the default charset for use when no explicit charset parameter is provided by the sender.
    `void` | `setFieldName​(java.lang.String fieldName)` | Sets the field name used to reference this file item.
    `void` | `setFormField​(boolean state)` | Specifies whether or not a `FileItem` instance represents a simple form field.
    `void` | `setHeaders​(FileItemHeaders pHeaders)` | Sets the file item headers.
    `java.lang.String` | `toString()` | Returns a string representation of this object.
    `void` | `write​(java.io.File file)` | A convenience method to write an uploaded item to disk.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_CHARSET

          public static final java.lang.String DEFAULT_CHARSET

      Default content charset to be used when no explicit charset parameter is provided by the sender. Media subtypes of the "text" type are defined to have a default charset value of "ISO-8859-1" when received via HTTP.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DiskFileItem

          public DiskFileItem​(java.lang.String fieldName,
                              java.lang.String contentType,
                              boolean isFormField,
                              java.lang.String fileName,
                              int sizeThreshold,
                              java.io.File repository)

      Constructs a new `DiskFileItem` instance.
      Parameters:
        `fieldName` - The name of the form field.
        `contentType` - The content type passed by the browser or `null` if not specified.
        `isFormField` - Whether or not this item is a plain form field, as opposed to a file upload.
        `fileName` - The original file name in the user's file system, or `null` if not specified.
        `sizeThreshold` - The threshold, in bytes, below which items will be retained in memory and above which they will be stored as a file.
        `repository` - The data repository, which is the directory in which files will be created, should the item size exceed the threshold.

  - ### Method Detail

    - #### getInputStream

          public java.io.InputStream getInputStream()
                                             throws java.io.IOException

      Returns an `InputStream` that can be used to retrieve the contents of the file.
      Specified by:
        `getInputStream` in interface `FileItem`
      Returns:
        An `InputStream` that can be used to retrieve the contents of the file.
      Throws:
        `java.io.IOException` - if an error occurs.

    - #### getContentType

          public java.lang.String getContentType()

      Returns the content type passed by the agent or `null` if not defined.
      Specified by:
        `getContentType` in interface `FileItem`
      Returns:
        The content type passed by the agent or `null` if not defined.

    - #### getCharSet

          public java.lang.String getCharSet()

      Returns the content charset passed by the agent or `null` if not defined.
      Returns:
        The content charset passed by the agent or `null` if not defined.

    - #### getName

          public java.lang.String getName()

      Returns the original file name in the client's file system.
      Specified by:
        `getName` in interface `FileItem`
      Returns:
        The original file name in the client's file system.
      Throws:
        `InvalidFileNameException` - The file name contains a NUL character, which might be an indicator of a security attack. If you intend to use the file name anyways, catch the exception and use `InvalidFileNameException.getName()`.

    - #### isInMemory

          public boolean isInMemory()

      Provides a hint as to whether or not the file contents will be read from memory.
      Specified by:
        `isInMemory` in interface `FileItem`
      Returns:
        `true` if the file contents will be read from memory; `false` otherwise.

    - #### getSize

          public long getSize()

      Returns the size of the file.
      Specified by:
        `getSize` in interface `FileItem`
      Returns:
        The size of the file, in bytes.

    - #### get

          public byte[] get()
                     throws java.io.IOException

      Returns the contents of the file as an array of bytes. If the contents of the file were not yet cached in memory, they will be loaded from the disk storage and cached.
      Specified by:
        `get` in interface `FileItem`
      Returns:
        The contents of the file as an array of bytes or `null` if the data cannot be read
      Throws:
        `java.io.IOException` - if an I/O error occurs

    - #### getString

          public java.lang.String getString​(java.lang.String charset)
                                     throws java.io.UnsupportedEncodingException,
                                            java.io.IOException

      Returns the contents of the file as a String, using the specified encoding. This method uses `get()` to retrieve the contents of the file.
      Specified by:
        `getString` in interface `FileItem`
      Parameters:
        `charset` - The charset to use.
      Returns:
        The contents of the file, as a string.
      Throws:
        `java.io.UnsupportedEncodingException` - if the requested character encoding is not available.
        `java.io.IOException` - if an I/O error occurs

    - #### getString

          public java.lang.String getString()

      Returns the contents of the file as a String, using the default character encoding. This method uses `get()` to retrieve the contents of the file. TODO Consider making this method throw UnsupportedEncodingException.
      Specified by:
        `getString` in interface `FileItem`
      Returns:
        The contents of the file, as a string.

    - #### write

          public void write​(java.io.File file)
                     throws java.lang.Exception

      A convenience method to write an uploaded item to disk. The client code is not concerned with whether or not the item is stored in memory, or on disk in a temporary location. They just want to write the uploaded item to a file.

      This implementation first attempts to rename the uploaded item to the specified destination file, if the item was originally written to disk. Otherwise, the data will be copied to the specified file.

      This method is only guaranteed to work once, the first time it is invoked for a particular item. This is because, in the event that the method renames a temporary file, that file will no longer be available to copy or rename again at a later time.

      Specified by:
        `write` in interface `FileItem`
      Parameters:
        `file` - The `File` into which the uploaded item should be stored.
      Throws:
        `java.lang.Exception` - if an error occurs.

    - #### delete

          public void delete()

      Deletes the underlying storage for a file item, including deleting any associated temporary disk file. Although this storage will be deleted automatically when the `FileItem` instance is garbage collected, this method can be used to ensure that this is done at an earlier time, thus preserving system resources.
      Specified by:
        `delete` in interface `FileItem`

    - #### getFieldName

          public java.lang.String getFieldName()

      Returns the name of the field in the multipart form corresponding to this file item.
      Specified by:
        `getFieldName` in interface `FileItem`
      Returns:
        The name of the form field.
      See Also:
        `setFieldName(java.lang.String)`

    - #### setFieldName

          public void setFieldName​(java.lang.String fieldName)

      Sets the field name used to reference this file item.
      Specified by:
        `setFieldName` in interface `FileItem`
      Parameters:
        `fieldName` - The name of the form field.
      See Also:
        `getFieldName()`

    - #### isFormField

          public boolean isFormField()

      Determines whether or not a `FileItem` instance represents a simple form field.
      Specified by:
        `isFormField` in interface `FileItem`
      Returns:
        `true` if the instance represents a simple form field; `false` if it represents an uploaded file.
      See Also:
        `setFormField(boolean)`

    - #### setFormField

          public void setFormField​(boolean state)

      Specifies whether or not a `FileItem` instance represents a simple form field.
      Specified by:
        `setFormField` in interface `FileItem`
      Parameters:
        `state` - `true` if the instance represents a simple form field; `false` if it represents an uploaded file.
      See Also:
        `isFormField()`

    - #### getOutputStream

          public java.io.OutputStream getOutputStream()

      Returns an `OutputStream` that can be used for storing the contents of the file.
      Specified by:
        `getOutputStream` in interface `FileItem`
      Returns:
        An `OutputStream` that can be used for storing the contents of the file.

    - #### getStoreLocation

          public java.io.File getStoreLocation()

      Returns the `File` object for the `FileItem`'s data's temporary location on the disk. Note that for `FileItem`s that have their data stored in memory, this method will return `null`. When handling large files, you can use `File.renameTo(java.io.File)` to move the file to new location without copying the data, if the source and destination locations reside within the same logical volume.
      Returns:
        The data file, or `null` if the data is stored in memory.

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Removes the file contents from the temporary storage.
      Overrides:
        `finalize` in class `java.lang.Object`
      Throws:
        `java.lang.Throwable`

    - #### getTempFile

          protected java.io.File getTempFile()

      Creates and returns a `File` representing a uniquely named temporary file in the configured repository path. The lifetime of the file is tied to the lifetime of the `FileItem` instance; the file will be deleted when the instance is garbage collected.

      Note: Subclasses that override this method must ensure that they return the same File each time.

      Returns:
        The `File` to be used for temporary storage.

    - #### toString

          public java.lang.String toString()

      Returns a string representation of this object.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of this object.

    - #### getHeaders

          public FileItemHeaders getHeaders()

      Returns the file item headers.
      Specified by:
        `getHeaders` in interface `FileItemHeadersSupport`
      Returns:
        The file items headers.

    - #### setHeaders

          public void setHeaders​(FileItemHeaders pHeaders)

      Sets the file item headers.
      Specified by:
        `setHeaders` in interface `FileItemHeadersSupport`
      Parameters:
        `pHeaders` - The file items headers.

    - #### getDefaultCharset

          public java.lang.String getDefaultCharset()

      Returns the default charset for use when no explicit charset parameter is provided by the sender.
      Returns:
        the default charset

    - #### setDefaultCharset

          public void setDefaultCharset​(java.lang.String charset)

      Sets the default charset for use when no explicit charset parameter is provided by the sender.
      Parameters:
        `charset` - the default charset